#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc7'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 7)
__CHEETAH_genTime__ = 1182628499.9188061
__CHEETAH_genTimestamp__ = 'Sat Jun 23 21:54:59 2007'
__CHEETAH_src__ = 'share/wikiuv.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Jun 23 21:54:57 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class wikiuv(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        Template.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):


        """
        2.1
        """

        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('#TITLE ')
        _v = VFFSL(SL,"conf.description",True) # '$conf.description' on line 2, col 8
        if _v is not None: write(_filter(_v, rawExpr='$conf.description')) # from line 2, col 8.
        write('\n= ')
        _v = VFFSL(SL,"conf.description",True) # '$conf.description' on line 3, col 3
        if _v is not None: write(_filter(_v, rawExpr='$conf.description')) # from line 3, col 3.
        write('\n')
        if VFFSL(SL,"do_main",True): # generated from line 4, col 1
            _v = VFFSL(SL,"repodesc",True) # '$repodesc' on line 5, col 1
            if _v is not None: write(_filter(_v, rawExpr='$repodesc')) # from line 5, col 1.
            write('''
+== The following distribution releases are available  
-----
''')
            for r in VFFSL(SL,"releasekeys",True): # generated from line 8, col 1
                write('  \n  [')
                _v = VFFSL(SL,"r",True) # '$r' on line 10, col 4
                if _v is not None: write(_filter(_v, rawExpr='$r')) # from line 10, col 4.
                write(' wiki://dists/')
                _v = VFFSL(SL,"r",True) # '$r' on line 10, col 20
                if _v is not None: write(_filter(_v, rawExpr='$r')) # from line 10, col 20.
                write('] ')
                _v = VFFSL(SL,"releases",True)[VFFSL(SL,"r",True)] # '$releases[$r]' on line 10, col 24
                if _v is not None: write(_filter(_v, rawExpr='$releases[$r]')) # from line 10, col 24.
                write(' /\n')
            write('+== The following architectures are supported\n----\n')
            for a in VFN(VFFSL(SL,"conf",True),"architectures",True)[0:]: # generated from line 14, col 1
                write('+**')
                _v = VFFSL(SL,"a",True) # '$a' on line 15, col 4
                if _v is not None: write(_filter(_v, rawExpr='$a')) # from line 15, col 4.
                write('**\n')
            if VFFSL(SL,"conf.gpgkey",True): # generated from line 17, col 1
                write('''+== Authenticated packages
----
Packages is this repository can be gpg authenticated. The key that is
being used for signing the packages is ''')
                _v = VFFSL(SL,"conf.gpgkey",True) # '$conf.gpgkey' on line 21, col 40
                if _v is not None: write(_filter(_v, rawExpr='$conf.gpgkey')) # from line 21, col 40.
                write('''. You can
enter this key into the APT trusted keys database with the following
command:
[*
+wget ''')
                _v = VFFSL(SL,"webbase",True) # '$webbase' on line 25, col 7
                if _v is not None: write(_filter(_v, rawExpr='$webbase')) # from line 25, col 7.
                write('/')
                _v = VFFSL(SL,"conf.gpgkey",True) # '${conf.gpgkey}' on line 25, col 16
                if _v is not None: write(_filter(_v, rawExpr='${conf.gpgkey}')) # from line 25, col 16.
                write('.gpg -O- | sudo apt-key add -\n*]\n')
            if VFFSL(SL,"conf.mirrors",True): # generated from line 28, col 1
                write('=== The following mirrors are available\n*\n')
                for m in VFFSL(SL,"conf.mirrors",True): # generated from line 31, col 1
                    write('0\n[')
                    _v = VFFSL(SL,"m.webbase",True) # '$m.webbase' on line 33, col 2
                    if _v is not None: write(_filter(_v, rawExpr='$m.webbase')) # from line 33, col 2.
                    write(' ')
                    _v = VFFSL(SL,"m.webbase",True) # '$m.webbase' on line 33, col 13
                    if _v is not None: write(_filter(_v, rawExpr='$m.webbase')) # from line 33, col 13.
                    write(']/\nSponsored by **')
                    _v = VFFSL(SL,"m.sponsor",True) # '$m.sponsor' on line 34, col 16
                    if _v is not None: write(_filter(_v, rawExpr='$m.sponsor')) # from line 34, col 16.
                    write('**\n  \n')
                write('     \n')
            write('**You are currently using the\n')
            if VFFSL(SL,"sponsor",True): # generated from line 40, col 1
                write('mirror at ')
                _v = VFFSL(SL,"webbase",True) # '$webbase' on line 41, col 11
                if _v is not None: write(_filter(_v, rawExpr='$webbase')) # from line 41, col 11.
                write(' provided by ')
                _v = VFFSL(SL,"sponsor",True) # '$sponsor' on line 41, col 32
                if _v is not None: write(_filter(_v, rawExpr='$sponsor')) # from line 41, col 32.
                write('\n')
            else: # generated from line 42, col 1
                write('main archive at ')
                _v = VFFSL(SL,"webbase",True) # '$webbase' on line 43, col 17
                if _v is not None: write(_filter(_v, rawExpr='$webbase')) # from line 43, col 17.
                write('\n')
            write('**\n')
        elif VFFSL(SL,"do_release_main",True): # generated from line 46, col 1
            write('''+== Release info
----
  |** Release info|
  | **Release name:**|''')
            _v = VFFSL(SL,"release",True) # '$release' on line 50, col 23
            if _v is not None: write(_filter(_v, rawExpr='$release')) # from line 50, col 23.
            write('|\n  | **Version:**|')
            _v = VFFSL(SL,"conf.version",True) # '$conf.version' on line 51, col 18
            if _v is not None: write(_filter(_v, rawExpr='$conf.version')) # from line 51, col 18.
            write('|\n  |**')
            _v = VFFSL(SL,"repodesc",True) # '$repodesc' on line 52, col 6
            if _v is not None: write(_filter(_v, rawExpr='$repodesc')) # from line 52, col 6.
            write('''|

+== The following components are available:
----
''')
            for key in VFFSL(SL,"componentkeys",True): # generated from line 56, col 1
                write('\n**')
                _v = VFFSL(SL,"key",True) # '$key' on line 58, col 3
                if _v is not None: write(_filter(_v, rawExpr='$key')) # from line 58, col 3.
                write('** ([browse contents wiki://')
                _v = VFFSL(SL,"components",True)[key][0] # '$components[key][0]' on line 58, col 35
                if _v is not None: write(_filter(_v, rawExpr='$components[key][0]')) # from line 58, col 35.
                write('])/\n')
                _v = VFFSL(SL,"components",True)[key][1] # '$components[key][1]' on line 59, col 1
                if _v is not None: write(_filter(_v, rawExpr='$components[key][1]')) # from line 59, col 1.
                write('\n\n')
        else: # generated from line 62, col 1
            write('== Component ')
            _v = VFFSL(SL,"component",True) # '$component' on line 63, col 14
            if _v is not None: write(_filter(_v, rawExpr='$component')) # from line 63, col 14.
            write('\n----\n')
            _v = VFFSL(SL,"desc",True) # '$desc' on line 65, col 1
            if _v is not None: write(_filter(_v, rawExpr='$desc')) # from line 65, col 1.
            write('''

You can use apt to download and install the packages. Use the following
lines in /etc/apt/sources.list and use the command sudo
apt-get update to enable downloading from this component.

Don't forget to read the notice on the [frontpage! wiki://''')
            _v = VFFSL(SL,"webbase",True) # '$webbase' on line 71, col 59
            if _v is not None: write(_filter(_v, rawExpr='$webbase')) # from line 71, col 59.
            write(']\n[*\ndeb ')
            _v = VFFSL(SL,"webbase",True) # '$webbase' on line 73, col 5
            if _v is not None: write(_filter(_v, rawExpr='$webbase')) # from line 73, col 5.
            write(' ')
            _v = VFFSL(SL,"release",True) # '$release' on line 73, col 14
            if _v is not None: write(_filter(_v, rawExpr='$release')) # from line 73, col 14.
            write(' ')
            _v = VFFSL(SL,"component",True) # '$component' on line 73, col 23
            if _v is not None: write(_filter(_v, rawExpr='$component')) # from line 73, col 23.
            write(' /\ndeb-src ')
            _v = VFFSL(SL,"webbase",True) # '$webbase' on line 74, col 9
            if _v is not None: write(_filter(_v, rawExpr='$webbase')) # from line 74, col 9.
            write(' ')
            _v = VFFSL(SL,"release",True) # '$release' on line 74, col 18
            if _v is not None: write(_filter(_v, rawExpr='$release')) # from line 74, col 18.
            write(' ')
            _v = VFFSL(SL,"component",True) # '$component' on line 74, col 27
            if _v is not None: write(_filter(_v, rawExpr='$component')) # from line 74, col 27.
            write('''
*]
== Packages
''')
            for s in VFFSL(SL,"sourcekeys",True): # generated from line 77, col 1
                s = VFFSL(SL,"sources",True)[VFFSL(SL,"s",True)]
                write('----\n=== ')
                _v = VFFSL(SL,"s",True)['Package'] # "$s['Package']" on line 80, col 5
                if _v is not None: write(_filter(_v, rawExpr="$s['Package']")) # from line 80, col 5.
                write('\n\n|Version:| ')
                _v = VFFSL(SL,"s",True)['Version'] # "$s['Version']" on line 82, col 12
                if _v is not None: write(_filter(_v, rawExpr="$s['Version']")) # from line 82, col 12.
                write('|\n')
                for f in VFFSL(SL,"s.ffiles",True): # generated from line 83, col 1
                    write('|Source (')
                    _v = VFFSL(SL,"f",True)[3] # '$f[3]' on line 84, col 10
                    if _v is not None: write(_filter(_v, rawExpr='$f[3]')) # from line 84, col 10.
                    write(')| : [ ')
                    _v = VFFSL(SL,"f",True)[2] # '$f[2]' on line 84, col 22
                    if _v is not None: write(_filter(_v, rawExpr='$f[2]')) # from line 84, col 22.
                    write(' wiki://../../../')
                    _v = VFFSL(SL,"s",True)['Directory'] # "$s['Directory']" on line 84, col 44
                    if _v is not None: write(_filter(_v, rawExpr="$s['Directory']")) # from line 84, col 44.
                    write('/')
                    _v = VFFSL(SL,"f",True)[2] # '$f[2]' on line 84, col 60
                    if _v is not None: write(_filter(_v, rawExpr='$f[2]')) # from line 84, col 60.
                    write(']|\n')
                write('\n')
                for p in VFFSL(SL,"s.packages",True): # generated from line 87, col 2
                    q = VFFSL(SL,"p",True)[0]
                    write('[*\n**--Description:--** ')
                    _v = VFFSL(SL,"q",True)['Description'] # "${q['Description']}" on line 90, col 22
                    if _v is not None: write(_filter(_v, rawExpr="${q['Description']}")) # from line 90, col 22.
                    write('\n*]\n')
                    for q in VFFSL(SL,"p",True): # generated from line 92, col 5
                        if VFFSL(SL,"q",True) == 0: # generated from line 93, col 7
                            continue
                        q = VFFSL(SL,"p",True)[VFFSL(SL,"q",True)]
                        if VFFSL(SL,"q",True)['Filename']: # generated from line 97, col 11
                            write('|Package:| [ ')
                            _v = VFN(VFFSL(SL,"q",True)['Filename'],"split",False)('/')[-1] # "${q['Filename'].split('/')[-1]}" on line 98, col 14
                            if _v is not None: write(_filter(_v, rawExpr="${q['Filename'].split('/')[-1]}")) # from line 98, col 14.
                            write(' wiki://../../../')
                            _v = VFFSL(SL,"q",True)['Filename'] # "$q['Filename']" on line 98, col 62
                            if _v is not None: write(_filter(_v, rawExpr="$q['Filename']")) # from line 98, col 62.
                            write('"]|\n')
        write('-----\n+**This repository is managed with the Falcon repository builder, version 1.5.4**\n+Falcon is \xc2\xa9 Dennis Kaarsemaker <dennis@kaarsemaker.net>')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_wikiuv= 'respond'

## END CLASS DEFINITION

if not hasattr(wikiuv, '_initCheetahAttributes'):
    templateAPIClass = getattr(wikiuv, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(wikiuv)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=wikiuv()).run()


